library IEEE;
use IEEE.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

entity reset_gen_ctr is
port (
      ck    : in  STD_LOGIC;
      axi_nres : OUT  STD_LOGIC      );
end reset_gen_ctr;

architecture arch_reset_gen_ctr of reset_gen_ctr is
signal ctr_state        :  STD_LOGIC_VECTOR( 3 downto 0) := x"0";
signal nxt_ctr_state    :  STD_LOGIC_VECTOR( 3 downto 0) := x"0";

begin
nxt_ctr_state <= "1000"   when ctr_state = "1000" else ctr_state + 1;
axi_nres <= ctr_state(3);
clkd:Process(ck)
Begin
    if (ck'EVENT AND ck='1') THEN
        ctr_state <= nxt_ctr_state ;
    end if;
END PROCESS clkd;
end arch_reset_gen_ctr;
